# Duplex

*MIDI/OSC controller framework for Renoise.*

Duplex is a collection of scripts that you install as a single Renoise tool. The scripts can run on a wide range of hardware, and works together to offer full, bi-directional control of the Renoise mixer/effects/pattern matrix. But Duplex is also about the weird and wonderful stuff, like custom-built sequencers and performance tools.

What makes Duplex special is the strong focus on bi-directional communication. In practice, this will ensure that your controller is always in sync with Renoise, no matter if you change a value on screen, or via your controller. Duplex is also highly configurable and encourages 'hacking via configuration files'. 

## [Installation](Docs/Installation.md)

## [Getting Started](Docs/GettingStarted.md)

## [Bundled Applications](Docs/Applications.md)

## [Devices & Troubleshooting](Docs/Controllers.md)

## [Custom Configurations](Docs/Configurations.md)

## [Control-Map Reference](Docs/Controlmaps.md)

## [Frequently Asked Questions](Docs/FAQ.md)

## [Links and Resources](Docs/Resources.md)

